// SPDX-License-Identifier: Apache-2.0
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { CommandHandler } from "../../../../../core/decorator/CommandHandlerDecorator";
import Injectable from "../../../../../core/injectable/Injectable";
import { DisconnectCommand, DisconnectCommandResponse } from "./DisconnectCommand";
import { DisconnectCommandError } from "./error/DisconnectCommandError";
let DisconnectCommandHandler = class DisconnectCommandHandler {
    async execute() {
        try {
            const handler = Injectable.resolveTransactionHandler();
            const res = await handler.stop();
            return new DisconnectCommandResponse(res);
        }
        catch (error) {
            throw new DisconnectCommandError(error);
        }
    }
};
DisconnectCommandHandler = __decorate([
    CommandHandler(DisconnectCommand)
], DisconnectCommandHandler);
export { DisconnectCommandHandler };
